%define anolis_release 8
%define debug_package %{nil}
%global kernel_version %(rpm -qa kernel-devel | sed -e 's/kernel-devel-//g')
%define QAT_release 00004

Summary: QAT package(Library and sample application)
Name: kmod-intel-QAT20
Version: L.0.9.4
Release: %{QAT_release}.%{anolis_release}%{dist}
Group: QAT/Base
License: BSD and (BSD or GPLv2)
Source: %{name}-%{version}-%{QAT_release}.tar.gz
Patch1000: 1000-bugfix-support-5.10.patch
Patch1001: 1001-bugfix-split-qat-vdcm-module.patch
Patch1002: 1002-bugfix-crash-of-rmmod-vdcm.patch

BuildRequires: gcc gcc-c++ make systemd-devel openssl-devel zlib-devel yasm
BuildRequires: libudev-devel >= 1.47
BuildRequires: kernel-devel >= 5.10.112
BuildRequires: kernel-core >= 5.10.112
BuildRequires: boost-devel
Provides: kmod-intel-QAT20-driver = %{version}-%{release}
Obsoletes: kmod-intel-QAT20-driver <  %{version}-%{release}
ExclusiveArch: x86_64

%description
Intel(R) QuickAssist Technology user space library and sample application Linux
version %{version}

%prep
%autosetup -c %{name}-%{version} -p1

%build
unset ICP_ROOT ICP_ARCH_USER ICP_BUILDSYSTEM_PATH ICP_BUILD_OUTPUT ICP_ENV_DIR ICP_TOOLS_TARGET
%configure
%make_build qat-driver-all quickassist-all

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/etc/init.d
mkdir -p %{buildroot}/etc/udev/rules.d
mkdir -p %{buildroot}/%{_libdir}
mkdir -p %{buildroot}%{_sbindir}
mkdir -p %{buildroot}/usr/bin/QAT
mkdir -p %{buildroot}/usr/bin/QAT/build
mkdir -p %{buildroot}/lib/firmware
MODPATH=drivers/crypto/qat
KERNEL_VER=%{kernel_version}
SRCMODDIR=${RPM_BUILD_DIR}/%{name}-%{version}/quickassist/qat/${MODPATH}
DSTMODDIR=%{buildroot}/lib/modules/${KERNEL_VER}/updates/${MODPATH}
mkdir -p %{buildroot}/lib/modules/${KERNEL_VER}/kernel
mkdir -p ${DSTMODDIR}/qat_common/
mkdir -p ${DSTMODDIR}/qat_4xxx/
mkdir -p ${DSTMODDIR}/qat_4xxxvf/
mkdir -p ${DSTMODDIR}/qat_vqat/

/usr/bin/install -D -m 750 ${SRCMODDIR}/qat_common/intel_qat.ko ${DSTMODDIR}/qat_common/
/usr/bin/install -D -m 750 ${SRCMODDIR}/qat_common/qat_vdcm.ko ${DSTMODDIR}/qat_common/
/usr/bin/install -D -m 750 ${SRCMODDIR}/qat_4xxx/qat_4xxx.ko ${DSTMODDIR}/qat_4xxx/qat_4xxx.ko
/usr/bin/install -D -m 750 ${SRCMODDIR}/qat_4xxxvf/qat_4xxxvf.ko ${DSTMODDIR}/qat_4xxxvf/qat_4xxxvf.ko
/usr/bin/install -D -m 750 ${SRCMODDIR}/qat_vqat/qat_vqat.ko ${DSTMODDIR}/qat_vqat/qat_vqat.ko
/usr/bin/install -D -m 750 build/usdm_drv.ko %{buildroot}/lib/modules/${KERNEL_VER}/kernel/

%clean
rm -rf $RPM_BUILD_ROOT

%verifyscript

%files
/lib/modules/%{kernel_version}/updates/drivers/crypto/qat/qat_common/intel_qat.ko
/lib/modules/%{kernel_version}/updates/drivers/crypto/qat/qat_common/qat_vdcm.ko
/lib/modules/%{kernel_version}/updates/drivers/crypto/qat/qat_4xxx/qat_4xxx.ko
/lib/modules/%{kernel_version}/updates/drivers/crypto/qat/qat_4xxxvf/qat_4xxxvf.ko
/lib/modules/%{kernel_version}/updates/drivers/crypto/qat/qat_vqat/qat_vqat.ko
/lib/modules/%{kernel_version}/kernel/usdm_drv.ko

%post
ECHO=/usr/bin/echo
${ECHO} "Creating module.dep file for QAT released kernel object"
${ECHO} "This will take a few moments";
depmod -a
${ECHO} "%{name}-driver-%{version}-%{release} is installed!";

%postun
depmod -a

%changelog
* Mon Nov 14 2022 Xuchun Shang <xuchun.shang@linux.alibaba.com> - 0.9.4-00004.8
- Remove QAT lib

* Wed Nov 09 2022 Hao Xiang <hao.xiang@linux.alibaba.com> - 0.9.4-00004.7
- Get current kernel version by executing uname

* Tue Oct 25 2022 Xuchun Shang <xuchun.shang@linux.alibaba.com> - 0.9.4-00004.6
- Fix kernel crash when rmmod qat_vdcm

* Fri Oct 21 2022 Xuchun Shang <xuchun.shang@linux.alibaba.com> - 0.9.4-00004.5
- Stop QAT service in tinyos by default

* Tue Oct 18 2022 Xuchun Shang <xuchun.shang@linux.alibaba.com> - 0.9.4-00004.4
- Fix bug in dc_sample_event_notif which leads to kernel crash

* Thu Oct 13 2022 Hao Xiang <hao.xiang@linux.alibaba.com> - 0.9.4-00004.3
- Split qat_vdcm module with qat_4xxx module

* Mon Sep 30 2022 Xin Zeng <xin.zeng@intel.com> - 0.9.4-00004.2
- Split kernel driver and library into separate packages

* Tue Aug 30 2022 Xin Zeng <xin.zeng@intel.com> - 0.9.4-00004.1
- Initial version of the package


